/***************************************************************************

FILE: adrsmode.cpp

PURPOSE: This contains the addressing modes mapping routines.  *SLOW*

Copyright 1997 Chad Kitching.  Read the readme.txt for license info.

***************************************************************************/
#include "snesstru.h"
#include "memory~1.h"
#include "65c816.h"
#include "opcodes1.h"
#include "regist~1.h"

unsigned long int special()
{
 return 0;
}

unsigned long int implied()
{
 return 0;
}

unsigned long int immediate()
{
 return PC+(PB<<16);
}

unsigned long int absolute()
{
 long int result;

 result=SNESgetword(PC,PB)+(PB<<16);
 PC+=2;
 return result;
}

unsigned long int absolute_long()
{
 unsigned long int result;

 result=SNESgetword(PC,PB)&0xFFFF+(SNESgetbyte(PC+2,PB)<<16);
 PC+=3;
 return result;
}

unsigned long int absolute_Xindexed()
{
 unsigned long int result;

 result=SNESgetword(PC,PB)&0xFFFF+(PB<<16)+X;
 PC+=2;
 return result;
}

unsigned long int absolute_Yindexed()
{
 unsigned long int result;

 result=SNESgetword(PC,PB)&0xFFFF+(PB<<16)+X;
 PC+=2;
 return result;
}

unsigned long int absolute_long_indexed()
{
 unsigned long int result;

 result=SNESgetword(PC,PB)&0xFFFF+(SNESgetbyte(PC+2,PB)<<16)+Y;
 PC+=3;
 t+=3;
 return result;
}

unsigned long int relative()
{
 unsigned long int result;
 result=PC+SNESgetbyte(PC,PB)+(PB<<16);
 PC++;
 return result;
}

unsigned short int accumulatorV()
{
 return A;
}

unsigned char absolute_long_indexedVb()
{
 unsigned char result;

 result=SNESgetbyte(SNESgetword(PC,PB)&0xFFFF+X,SNESgetbyte(PC+2,PB));
 PC+=3;
 t+=3;
 return result;
}

unsigned short int absolute_long_indexedVw()
{
 unsigned short int result;

 result=SNESgetword(SNESgetword(PC,PB)&0xFFFF+X,SNESgetbyte(PC+2,PB));
 PC+=3;
 t+=3;
 return result;
}

unsigned char immediateVb()
{
 unsigned char result;
 result=SNESgetbyte(PC,PB);
 PC++;
 return result;
}

unsigned short int immediateVw()
{
 unsigned short int result;
 result=SNESgetword(PC,PB);
 PC+=2;
 return result;
}

unsigned char absoluteVb()
{
 unsigned char result;
 result=SNESgetbyte(SNESgetword(PC,PB)&0xFFFF,PB);
 PC+=2;
 return result;
}

unsigned short int absoluteVw()
{
 unsigned short int result;
 result=SNESgetword(SNESgetword(PC,PB)&0xFFFF,PB);
 PC+=2;
 return result;
}

unsigned char absolute_longVb()
{
 unsigned char result;

 result=SNESgetbyte(SNESgetword(PC,PB)&0xFFFF,SNESgetbyte(PC+2,PB));
 PC+=3;
 return result;
}

unsigned short int absolute_longVw()
{
 unsigned short int result;

 result=SNESgetword(SNESgetword(PC,PB)&0xFFFF,SNESgetbyte(PC+2,PB));
 PC+=3;
 return result;
}

unsigned char absolute_XindexedVb()
{
 unsigned char result;

 result=SNESgetbyte(SNESgetword(PC,PB)&0xFFFF+X,DB);
 PC+=2;
 return result;
}

unsigned short int absolute_XindexedVw()
{
 unsigned short int result;

 result=SNESgetbyte(SNESgetword(PC,PB)&0xFFFF+X,DB);
 PC+=2;
 return result;
}

unsigned char absolute_YindexedVb()
{
 unsigned char result;

 result=SNESgetbyte(SNESgetword(PC,PB)&0xFFFF+X,DB);
 PC+=2;
 return result;
}

unsigned short int absolute_YindexedVw()
{
 unsigned short int result;

 result=SNESgetbyte(SNESgetword(PC,PB)&0xFFFF+X,DB);
 PC+=2;
 return result;
}

unsigned long int direct()
{
 if (D&0xFF!=0) t++;
 t++;
 return (SNESgetbyte(PC,PB)+D)&0xFFFF;
}

unsigned char directVb()
{
 if (D&0xFF!=0) t++;
 t++;
 return SNESgetbyte(SNESgetbyte(PC,PB)+D,0);
}

unsigned short int directVw()
{
 if (D&0xFF!=0) t++;
 t++;
 return SNESgetword(SNESgetbyte(PC,PB)+D,0);
}

unsigned long int direct_indir_indexed_y()
{
 t+=3;
 return ((SNESgetword(SNESgetbyte(PC,PB)+D,0)+Y)&0xFFFF)+(DB<<16);
}

unsigned char direct_indir_indexed_yVb()
{
 t+=3;
 return SNESgetbyte(((SNESgetword(SNESgetbyte(PC,PB)+D,0)+Y)&0xFFFF),DB);
}

unsigned short int direct_indir_indexed_yVw()
{
 t+=3;
 return SNESgetword(((SNESgetword(SNESgetbyte(PC,PB)+D,0)+Y)&0xFFFF),DB);
}

unsigned long int dir_indir_indexed_long()
{
 t+=4;
 unsigned short int tmpaddr;
 tmpaddr=SNESgetbyte(PC,PB)+D;
 return ((SNESgetword(tmpaddr,0)+Y)&0xFFFF)+SNESgetbyte(tmpaddr+2,0)<<16;
}

unsigned char dir_indir_indexed_longVb()
{
 t+=4;
 unsigned short int tmpaddr;
 tmpaddr=SNESgetbyte(PC,PB)+D;
 return SNESgetbyte(((SNESgetword(tmpaddr,0)+Y)&0xFFFF),SNESgetbyte(tmpaddr+2,0));
}

unsigned short int dir_indir_indexed_longVw()
{
 t+=4;
 unsigned short int tmpaddr;
 tmpaddr=SNESgetbyte(PC,PB)+D;
 return SNESgetword(((SNESgetword(tmpaddr,0)+Y)&0xFFFF),SNESgetbyte(tmpaddr+2,0));
}

unsigned long int direct_indexed_indir()
{
 t+=4;
 return SNESgetword((D+SNESgetbyte(PC,PB)+X)&0xFFFF,0)+DB<<16;
}

unsigned short int direct_indexed_indirVb()
{
 t+=4;
 return SNESgetbyte(SNESgetword((D+SNESgetbyte(PC,PB)+X)&0xFFFF,0),DB);
}

unsigned char direct_indexed_indirVw()
{
 t+=4;
 return SNESgetword(SNESgetword((D+SNESgetbyte(PC,PB)+X)&0xFFFF,0),DB);
}

unsigned long int direct_indexed_x()
{
 t+=2;
 return (D+SNESgetbyte(PC,PB)+X)&0xFFFF;
}

unsigned char direct_indexed_xVb()
{
 t+=2;
 return SNESgetbyte(D+SNESgetbyte(PC,PB)+X,0);
}

unsigned short int direct_indexed_xVw()
{
 t+=2;
 return SNESgetword(D+SNESgetbyte(PC,PB)+X,0);
}

unsigned long int direct_indexed_y()
{
 t+=2;
 return (D+SNESgetbyte(PC,PB)+Y)&0xFFFF;
}

unsigned char direct_indexed_yVb()
{
 t+=2;
 return SNESgetbyte(D+SNESgetbyte(PC,PB)+Y,0);
}

unsigned short int direct_indexed_yVw()
{
 t+=2;
 return SNESgetword(D+SNESgetbyte(PC,PB)+Y,0);
}

unsigned long int direct_indir()
{
 t+=3;
 return SNESgetword((D+SNESgetbyte(PC,PB))&0xFFFF,0)+DB<<16;
}

unsigned char direct_indirVb()
{
 t+=3;
 return SNESgetbyte(SNESgetword((D+SNESgetbyte(PC,PB))&0xFFFF,0),DB);
}

unsigned short int direct_indirVw()
{
 t+=3;
 return SNESgetword(SNESgetword((D+SNESgetbyte(PC,PB))&0xFFFF,0),DB);
}

unsigned long int direct_indir_long()
{
 int myaddr;
 t+=4;
 myaddr=(D+SNESgetbyte(PC,PB))&0xFFFF;
 return SNESgetword(myaddr,00)+(SNESgetbyte(myaddr+2,00)<<16);
}

unsigned short int direct_indir_longVw()
{
 int myaddr;
 t+=4;
 myaddr=(D+SNESgetbyte(PC,PB))&0xFFFF;
 return SNESgetword(SNESgetword(myaddr,00),SNESgetbyte(myaddr+2,00));
}

unsigned char direct_indir_longVb()
{
 int myaddr;
 t+=4;
 myaddr=(D+SNESgetbyte(PC,PB))&0xFFFF;
 return SNESgetbyte(SNESgetword(myaddr,00),SNESgetbyte(myaddr+2,00));
}


