/** VGB: portable GameBoy emulator ***************************/
/**                                                         **/
/**                          Help.h                         **/
/**                                                         **/
/** This file contains help information printed out by the  **/
/** main() routine when started with option "-help".        **/
/**                                                         **/
/** Copyright (C) Marat Fayzullin 1994,1995                 **/
/**               Marcel de Kogel 1996                      **/
/**     You are not allowed to distribute this software     **/
/**     commercially. Please, notify me, if you make any    **/
/**     changes to this file.                               **/
/*************************************************************/

char *HelpText[] =
{
  "\nUsage: vgb [-option1 [-option2...]] <filename>",
  "<filename> = name of file to load as cartridge",
  "[-option]  =",
  "  -verbose <level>                - Select debugging messages [1]",
  "                                    0 - Silent           1 - Startup messages",
  "                                    2 - Illegal writes   4 - Illegal CPU ops",
  "                                    8 - Bank switching", 
  "  -ifreq <frequency>              - Set VBlank interrupt frequency [60Hz]",
  "                                    Use -ifreq 0 to disable sync",
  "  -vperiod [-vp] <period>         - Set VBlank interrupts period [69905 cycles]",
  "  -uperiod [-up]<period>          - Number of interrupts per screen update [0]",
  "                                    Use -uperiod 0 to enable real-time refresh",
  "                                    checking",
  "  -help                           - Print this help page",
  "  -cheat <GG code>                - Activate GameGenie cheat",
  "  -delay/-nodelay                 - Delay/Don't delay screen refresh [-delay]",
  "  -crc/-nocrc                     - Check/Don't check cartridge CRC [-crc]",
  "",
  "  -color0 [-c0] <name>            - Change color#0 [white]",
  "  -color1 [-c1] <name>            - Change color#1 [#B0B0B0]",
  "  -color2 [-c2] <name>            - Change color#2 [#606060]",
  "  -color3 [-c3] <name>            - Change color#3 [black]",
  "  -backgroundcolor0 [-bc0] <name> - Change background color#0 [white]",
  "  -backgroundcolor1 [-bc1] <name> - Change background color#1 [#B0B0B0]",
  "  -backgroundcolor2 [-bc2] <name> - Change background color#2 [#606060]",
  "  -backgroundcolor3 [-bc3] <name> - Change background color#3 [black]",
  "  -spritecolor0 [-sc0] <name>     - Change sprite color#0 [white]",
  "  -spritecolor1 [-sc1] <name>     - Change sprite color#1 [#B0B0B0]",
  "  -spritecolor2 [-sc2] <name>     - Change sprite color#2 [#606060]",
  "  -spritecolor3 [-sc3] <name>     - Change sprite color#3 [black]",
  "  -windowcolor0 [-wc0] <name>     - Change window color#0 [white]",
  "  -windowcolor1 [-wc1] <name>     - Change window color#1 [#B0B0B0]",
  "  -windowcolor2 [-wc2] <name>     - Change window color#2 [#606060]",
  "  -windowcolor3 [-wc3] <name>     - Change window color#3 [black]",
  "  -colorscheme [-cs] <scheme>     - Select color scheme [0]",
  "  -backgroundcolorscheme [-bcs] <scheme>",
  "  -spritecolorscheme [-scs] <scheme>",
  "  -windowcolorscheme [-scs] <scheme>",
  "  -definecolorscheme [-dcs] <scheme> <color0> <color1> <color2> <color3>",
  "                                - Define color scheme",
  "",
  "  -brightness [-br] <br>        - Select image brightness [0]",
  "                                  -100 - Darkest  100 - Brightest",
  "  -backgroundbrightness [-bbr] <br>",
  "  -spritebrightness [-sbr] <br>",
  "  -windowbrightness [-wbr] <br>",
  "  -video <mode>                 - Select video mode [0]",
  "                                  0 - 320x200 with title screen",
  "                                  1 - 320x200 without title screen",
  "                                  2 - 360x144",
  "                                  3 - 180x144",
  "                                  4 - 256x200 with title screen",
  "                                  5 - 256x200 without title screen",
  "  -background <file>            - Select .GIF file to use as background",
  "                                  image in video modes 0 and 4 [VGB-DOS.GIF]",
  "",
  "  -sound <mode>                 - Select sound mode [1]",
  "                                  0 - No sound  1 - Adlib",
  "  -stereo <mode>                - Select stereo mode [1]",
  "                                  0 - Mono      1 - Normal",
  "                                  2 - Reversed",
  "  -volume <volume>              - Set initial volume [10]",
  "                                  0 - Silent   15 - Maximum",
  "  -logsnd <filename>            - Select sound log file [NULL]",
  "  -swapbuttons [-swap] <flags>  - Swap/Do not swap buttons [0]",
  "                                  1 - Swap joystick buttons",
  "                                  2 - Swap keyboard buttons",
  "  -autoa <mode>                 - Select button A autofire mode [0]",
  "                                  0 - No autofire",
  "                                  1 - Autofire",
  "  -autob <mode>                 - Select button B autofire mode [0]",
  "                                  0 - No autofire",
  "                                  1 - Autofire",
  "  -keys <string>                - Alter key mappings",
  NULL
};
