/***************************************************************************

FILE: Memory~1.cpp   (was an lfn in one time of it's existance, I'm not renaming. =P

PURPOSE: These are the snes memory access routines.

Copyright 1997 Chad Kitching.  Read the readme.txt for license info.

***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "snesstru.h"
#include "memory~1.h"
#include "regist~1.h"

#define elif else if
//sorry for the above.  I'm going to be using 'else if' lots here, so, I don't want to type it 20 times.
unsigned char *CartROM, *SnesRAM, *SnesVRAM, *SnesSRAM;
unsigned char *VidBuffer[3];
static char port4212=0;
bginfo BG1Info, BG2Info, BG3Info, BG4Info, BGTemp;

#pragma warn -sig     //  I hate "Conversion may lose significant digits"
void AllocateRAM (void)
{
  int i;
  fputs("Getting memory...",stdout);
  fputs("SNES ROM...",stdout);
  if ((CartROM=(unsigned char*)calloc(4194309,1))==NULL)
  {
    puts("\nCouldn't allocate memory for cartridge ROM image!!\n");
    exit(255);
  }
  fputs("RAM...",stdout);
  if ((SnesRAM=(unsigned char*)calloc(131079,1))==NULL)
  {
    puts("\nCouldn't allocate memory for carridge RAM!!\n");
    exit(255);
  }
  fputs("VRAM...",stdout);
  if ((SnesVRAM=(unsigned char*)calloc(65540,1))==NULL)
  {
    puts("\nCouldn't allocate memory for cartridge video RAM!!\n");
    exit(255);
  }
  fputs("SRAM...",stdout);
  if ((SnesSRAM=(unsigned char*)calloc(262149,1))==NULL)
  {
    puts("\nCouldn't allocate memory for cartridge static RAM!!\n");
    exit(255);
  }
  puts("\nMemory Allocated for SNES memory...\n");
  for (i=1;i<3;i++) if ((VidBuffer[i]=(unsigned char*)calloc(65536,1))==NULL)
  {
    puts("Couldn't allocate memory for video buffers!!");
    exit(255);
  }
}

void LoadImage(char *File)
{
  FILE *file_ptr;
  long int i,Length;
  //bool outpit;

  if ((file_ptr=fopen(File,"rb"))==NULL)
  {
    puts("Couldn't open file for reading.\n");
    exit(255);
  }
  fseek(file_ptr,0,SEEK_END);
  Length=(ftell(file_ptr)-fileheader);
  fseek(file_ptr,fileheader,SEEK_SET);
  cputs("Reading ROM... [");
  for (i=0;i<Length;i+=65536) putch(' ');
  cputs("]");
  gotoxy(17,(int)wherey());
  for (i=0;i<Length;i+=65536)
     {
      if ((Length-i)<65536)
        {
         fread(CartROM+i,Length-i,1,file_ptr);
         cputs("P");
        }
      else
        {
         fread(CartROM+i,1,65536,file_ptr);
         cputs("B");
        }
     }
  puts("");
  fclose(file_ptr);
}

char SnesPORT(short int portno)
{
 #ifdef debug2
 printf("GFX Port queried: $%x\n",portno);
 #endif
 //switch
 return 0;
}

void SnesPORTob(unsigned short int portno, unsigned char byte)
{
 switch (portno)
   {
    case 0x2100:    //Brightness, screen enable WO
         break;
    case 0x2107:    //BG1 address selector.  And whatever the fuck SC is...
         printf("2107 called\n");
         BGTemp=BG1Info;
         BG1Info.BaseAddress=byte>>2;
         BG1Info.SCSize=byte&3;
         if ((BGTemp.BaseAddress!=BG1Info.BaseAddress)||(BGTemp.SCSize!=BG1Info.SCSize)) BG1Info.dirty=true;
         break;
    case 0x2108:    //BG2 address selector.  And whatever the fuck SC is...
         BGTemp=BG2Info;
         BG2Info.BaseAddress=byte>>2;
         BG2Info.SCSize=byte&3;
         if ((BGTemp.BaseAddress!=BG2Info.BaseAddress)||(BGTemp.SCSize!=BG2Info.SCSize)) BG2Info.dirty=true;
         break;
    case 0x2109:    //BG3 address selector.  And whatever the fuck SC is...
         BGTemp=BG3Info;
         BG3Info.BaseAddress=byte>>2;
         BG3Info.SCSize=byte&3;
         if ((BGTemp.BaseAddress!=BG3Info.BaseAddress)||(BGTemp.SCSize!=BG3Info.SCSize)) BG3Info.dirty=true;
         break;
    case 0x210A:    //BG4 address selector.  And whatever the fuck SC is...
         BGTemp=BG4Info;
         BG4Info.BaseAddress=byte>>2;
         BG4Info.SCSize=byte&3;
         if ((BGTemp.BaseAddress!=BG4Info.BaseAddress)||(BGTemp.SCSize!=BG4Info.SCSize)) BG4Info.dirty=true;
         break;

    default:
         return;
   }
 return;
}

char SnesDMAPort(short int portno)
{
 //char tmpret;
 #ifdef debug2
 printf("DMA Port queried: $%x\n",portno);
 #endif
 switch (portno)
   {
    case 0x4310:
         if (TrippedNMI)
           {
            TrippedNMI=false;
            return 0x80;
           }
         break;
    case 0x4212:
         if (port4212==0)
           port4212=0xC1;
         else
           port4212=0;
         return port4212;
    default:
         return 0;
   }
}

void FreeBuffers (void)
{
  int i;

  free(CartROM);
  free(SnesRAM);
  free(SnesVRAM);
  free(SnesSRAM);
  for (i=1;i<3;i++) free(VidBuffer[i]);
  puts("All allocated memory freed.");
}
//Maps SNES memory locations to the ram buffers.  Needs extensive optimizations.  Called a lot!!
void SnesMap (unsigned short int offset, unsigned char segment, MemType *type, long int *trueoffset)
{
  char lowseg=segment&0x7f;

  if (ROMType==LoROM)
  {
    if ((lowseg>=0x00)&&(lowseg<=0x3F))
    {
      if (offset>0x7FFF)                          // seg 0x00-0x37 offs 0x7FFF-0xFFFF
      {
        *type=SnesRom;                             //ROM here! Map it...
        *trueoffset=((lowseg<<0x0f)+(offset&0x7FFF))&0x3FFFFF;
      }
      elif (offset<0x1fff)                        // seg 0x00-0x37 offs 0x0000-0x1FFF
      {
        *type=SnesRam;                             //There be RAM mapped here.
        *trueoffset=((lowseg<<0x0d)+(offset&0x1FFF))&0x1FFFF;
      }
      else                                        // seg 0x00-0x37 all other offs
      {
        *type=SnesInvalid;                         //I dunno, black hole?
        *trueoffset=offset;
      }
    }
    elif ((lowseg>=112)&&(lowseg<=127))
    {
      if (offset<0x8000)                          // seg 0x70-0x7F offs 0x0000-0x7FFF
      {
        *type=SnesSRam;                            //SRAM, maybe I should only map IF sram exists?
        *trueoffset=(((lowseg-0x70)<<0xf)+(offset&0x7FFF))&0xFFFF;
        if ((lowseg==0x7E)||(lowseg==0x7F))        // seg 0x7e-0x7f offs: all
        {
          *type=SnesRam;                           // This is the part I am confused about I don't know what to map here!
          *trueoffset=(((lowseg-0x7E)<<0x10)+offset)&0x1FFFF;
        }
      }
    }
    if ((offset>=0x2100)&&(offset<0x3FFF))        // all segs offs 0x2100-0x21FF
    {
      *type=SnesPort;                              //Graphics ports
      *trueoffset=offset;
    }
    elif ((offset>=0x4200)&&(offset<0x5FFF))      // all segs offs 0x4200-0x421F
    {
      *type=SnesDMA;                               //The cursed DMA
      *trueoffset=offset;
    }
  }
  else
  {
  puts("HiROM not supported yet.");
  exit(255);
  }
}

void debugerr()
{
 printf("  Flags:  N:%i V:%i M:%i X:%i D:%i I:%i Z:%i C:%i E:%i\n",P.N,P.V,P.M,P.X,P.D,P.I,P.Z,P.C,P.E);
 printf("  Regs:   A: $%04x D: $%04x X: $%04x Y: $%04x\n",A,D,X,Y);
 printf("  Regs:   PB:  $%02x PC:$%04x DB:  $%02x S: $%04x\n",PB,PC,DB,S);
}

unsigned char SNESgetbyte(unsigned short int offs, unsigned char seg)
{
  long int realoffs;
  MemType Addresstype;

  SnesMap (offs, seg, &Addresstype, &realoffs);
  switch (Addresstype) {
    case SnesRom:
      return (unsigned char)CartROM[realoffs];
    case SnesRam:
      return (unsigned char)SnesRAM[realoffs];
    case SnesVRam:
      return (unsigned char)SnesVRAM[realoffs];
    case SnesSRam:
    	return (unsigned char)SnesSRAM[realoffs];
    case SnesPort:
      return (char)SnesPORT(offs);
    case SnesDMA:
      return (char)SnesDMAPort(offs);
    default:
      printf("invalid memory access  Offs:%x  Seg:%x",offs,seg);
      debugerr();
      exit(2);
  }
  return 0;           //just getting rid of an annoying warning...
}


unsigned short int SNESgetword(unsigned short int offs, unsigned char seg)  //Why doesn't this thing werk?!?
{
  long int realoffs;
  MemType Addresstype;

  SnesMap (offs, seg, &Addresstype, &realoffs);
  switch (Addresstype) {
    case SnesRom:
      return ((unsigned char)CartROM[realoffs])+((unsigned char)CartROM[realoffs+1]<<8);
    case SnesRam:
      return ((unsigned char)SnesRAM[realoffs])+((unsigned char)SnesRAM[realoffs+1]<<8);
    case SnesVRam:
      return (unsigned char)SnesVRAM[realoffs]+((unsigned char)SnesVRAM[realoffs+1]<<8);
    case SnesSRam:
    	return (unsigned char)SnesSRAM[realoffs]+((unsigned char)SnesSRAM[realoffs+1]<<8);
    case SnesPort:
      return (unsigned char)SnesPORT(offs)+((unsigned char)SnesPORT(offs+1)<<8);
    case SnesDMA:
      return (unsigned char)SnesDMAPort(offs)+((unsigned char)SnesPORT(offs+1)<<8);
    default:
      puts("invalid memory access");
      debugerr();
      exit(2);
  }
  return 0;           //just getting rid of an annoying warning...
}

void SNESsetbyte(MemType type, int offs, unsigned char byte)
{
  switch (type) {
    case SnesRom:
      CartROM[offs]=byte;
      break;
    case SnesRam:
      SnesRAM[offs]=byte;
      break;
    case SnesVRam:
      SnesVRAM[offs]=byte;
      break;
    case SnesSRam:
      SnesSRAM[offs]=byte;
      break;
    case SnesPort:
      #ifdef debug2
      printf("GFX Port written: %x <- %x\n",offs,byte);
      #endif
      SnesPORTob(offs,byte);
      //SnesPORT[offs]=byte;
      break;
    case SnesDMA:
      #ifdef debug2
      printf("DMA Port written: %x <- %x\n",offs,byte);
      #endif
      //SnesDMAPort[offs]=byte;
      break;
    default:
      puts("invalid memory access");
      debugerr();
      exit(2);
  }
}

void SNESsetword(MemType type, int offs, unsigned short int byte)
{
  switch (type) {
    case SnesRom:
      //CartROM[offs]=byte&0xff;
      break;
    case SnesRam:
      SnesRAM[offs]=byte&0xff;
      SnesRAM[offs+1]=byte>>8;
      break;
    case SnesVRam:
      SnesVRAM[offs]=byte&0xff;
      SnesVRAM[offs]=byte>>8;
      break;
    case SnesSRam:
      SnesSRAM[offs]=byte&0xff;
      SnesSRAM[offs]=byte>>8;
      break;
    case SnesPort:
         #ifdef debug2
         printf("GFX Port written: %x <- %x\n",offs,byte);
         #endif
         //SnesPORT[offs]=byte;
         break;
    case SnesDMA:
         #ifdef debug2
         printf("DMA Port written: %x <- %x\n",offs,byte);
         #endif
         //SnesDMAPort[offs]=byte;
         break;
    default:
      puts("invalid memory access");
      debugerr();
      exit(2);
  }
}

void Test13()
{
  //int i;

  //for (i=0xFFC0;i<0xFFFF;i++) printf("%x %c ",i,SNESgetbyte(i,0));

  //printf("\n %i %i",(int)SNESgetbyte(0xfffc,0),(int)SNESgetbyte(0xfffd,0));

  printf("\nNMI Vector: 0x%X\nReset Vector: 0x%X\n",SNESgetword(0xfffa,0),SNESgetword(0xfffc,0));
}

#pragma warn .sig
